/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CountriesModel } from '../models';
import { CountryModel } from '../models';
import { CountrySortingCommand } from '../models';
import { CreateCountryCommand } from '../models';
import { CreateMediaCommand } from '../models';
import { MediaModel } from '../models';
import { MediaType } from '../models';
import { MediasModel } from '../models';
import { SortingResultModel } from '../models';
import { TranslateCountryCommand } from '../models';
import { UpdateCountryCommand } from '../models';
import { UpdateMediaCommand } from '../models';
/**
 * CountriesApi - axios parameter creator
 * @export
 */
export declare const CountriesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete country.
     * @param {string} countryId
     * @param {boolean} [isPermanent] Admin only
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdDelete: (countryId: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get country.
     * @param {string} countryId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdGet: (countryId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all CountryMedias.
     * @param {string} countryId
     * @param {string} [id]
     * @param {MediaType} [mediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasGet: (countryId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete CountryMedia
     * @param {string} countryId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasMediaIdDelete: (countryId: string, mediaId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get CountryMedia.
     * @param {string} countryId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasMediaIdGet: (countryId: string, mediaId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update CountryMedia.
     * @param {string} countryId
     * @param {string} mediaId
     * @param {UpdateMediaCommand} [updateMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasMediaIdPut: (countryId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create CountryMedia.
     * @param {string} countryId
     * @param {CreateMediaCommand} [createMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasPost: (countryId: string, createMediaCommand?: CreateMediaCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update country.
     * @param {string} countryId
     * @param {UpdateCountryCommand} [updateCountryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdPut: (countryId: string, updateCountryCommand?: UpdateCountryCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Reactivate country.
     * @param {string} countryId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdReactivatePut: (countryId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Revalidate country
     * @param {string} countryId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdRevalidatePost: (countryId: string, includeCurrent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Translate country
     * @param {string} countryId
     * @param {TranslateCountryCommand} [translateCountryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdTranslatePost: (countryId: string, translateCountryCommand?: TranslateCountryCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all countries.
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [description]
     * @param {Date} [createdDate]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesGet: (id?: string, name?: string, description?: string, createdDate?: Date, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a country.
     * @param {CreateCountryCommand} [createCountryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesPost: (createCountryCommand?: CreateCountryCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get country by slug
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesSlugGet: (slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Batch for countries sorting
     * @param {CountrySortingCommand} [countrySortingCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesSortPut: (countrySortingCommand?: CountrySortingCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * CountriesApi - functional programming interface
 * @export
 */
export declare const CountriesApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete country.
     * @param {string} countryId
     * @param {boolean} [isPermanent] Admin only
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdDelete(countryId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get country.
     * @param {string} countryId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdGet(countryId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CountryModel>>;
    /**
     *
     * @summary Get all CountryMedias.
     * @param {string} countryId
     * @param {string} [id]
     * @param {MediaType} [mediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasGet(countryId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediasModel>>;
    /**
     *
     * @summary Delete CountryMedia
     * @param {string} countryId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasMediaIdDelete(countryId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get CountryMedia.
     * @param {string} countryId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasMediaIdGet(countryId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>>;
    /**
     *
     * @summary Update CountryMedia.
     * @param {string} countryId
     * @param {string} mediaId
     * @param {UpdateMediaCommand} [updateMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasMediaIdPut(countryId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>>;
    /**
     *
     * @summary Create CountryMedia.
     * @param {string} countryId
     * @param {CreateMediaCommand} [createMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasPost(countryId: string, createMediaCommand?: CreateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>>;
    /**
     *
     * @summary Update country.
     * @param {string} countryId
     * @param {UpdateCountryCommand} [updateCountryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdPut(countryId: string, updateCountryCommand?: UpdateCountryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CountryModel>>;
    /**
     *
     * @summary Reactivate country.
     * @param {string} countryId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdReactivatePut(countryId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Revalidate country
     * @param {string} countryId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdRevalidatePost(countryId: string, includeCurrent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Translate country
     * @param {string} countryId
     * @param {TranslateCountryCommand} [translateCountryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdTranslatePost(countryId: string, translateCountryCommand?: TranslateCountryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get all countries.
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [description]
     * @param {Date} [createdDate]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesGet(id?: string, name?: string, description?: string, createdDate?: Date, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CountriesModel>>;
    /**
     *
     * @summary Create a country.
     * @param {CreateCountryCommand} [createCountryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesPost(createCountryCommand?: CreateCountryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CountryModel>>;
    /**
     *
     * @summary Get country by slug
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CountryModel>>;
    /**
     *
     * @summary Batch for countries sorting
     * @param {CountrySortingCommand} [countrySortingCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesSortPut(countrySortingCommand?: CountrySortingCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SortingResultModel>>;
};
/**
 * CountriesApi - factory interface
 * @export
 */
export declare const CountriesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Delete country.
     * @param {string} countryId
     * @param {boolean} [isPermanent] Admin only
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdDelete(countryId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get country.
     * @param {string} countryId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdGet(countryId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<CountryModel>;
    /**
     *
     * @summary Get all CountryMedias.
     * @param {string} countryId
     * @param {string} [id]
     * @param {MediaType} [mediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasGet(countryId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<MediasModel>;
    /**
     *
     * @summary Delete CountryMedia
     * @param {string} countryId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasMediaIdDelete(countryId: string, mediaId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get CountryMedia.
     * @param {string} countryId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasMediaIdGet(countryId: string, mediaId: string, options?: any): AxiosPromise<MediaModel>;
    /**
     *
     * @summary Update CountryMedia.
     * @param {string} countryId
     * @param {string} mediaId
     * @param {UpdateMediaCommand} [updateMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasMediaIdPut(countryId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: any): AxiosPromise<MediaModel>;
    /**
     *
     * @summary Create CountryMedia.
     * @param {string} countryId
     * @param {CreateMediaCommand} [createMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdMediasPost(countryId: string, createMediaCommand?: CreateMediaCommand, options?: any): AxiosPromise<MediaModel>;
    /**
     *
     * @summary Update country.
     * @param {string} countryId
     * @param {UpdateCountryCommand} [updateCountryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdPut(countryId: string, updateCountryCommand?: UpdateCountryCommand, options?: any): AxiosPromise<CountryModel>;
    /**
     *
     * @summary Reactivate country.
     * @param {string} countryId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdReactivatePut(countryId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Revalidate country
     * @param {string} countryId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdRevalidatePost(countryId: string, includeCurrent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Translate country
     * @param {string} countryId
     * @param {TranslateCountryCommand} [translateCountryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesCountryIdTranslatePost(countryId: string, translateCountryCommand?: TranslateCountryCommand, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get all countries.
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [description]
     * @param {Date} [createdDate]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesGet(id?: string, name?: string, description?: string, createdDate?: Date, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<CountriesModel>;
    /**
     *
     * @summary Create a country.
     * @param {CreateCountryCommand} [createCountryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesPost(createCountryCommand?: CreateCountryCommand, options?: any): AxiosPromise<CountryModel>;
    /**
     *
     * @summary Get country by slug
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<CountryModel>;
    /**
     *
     * @summary Batch for countries sorting
     * @param {CountrySortingCommand} [countrySortingCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CountriesSortPut(countrySortingCommand?: CountrySortingCommand, options?: any): AxiosPromise<SortingResultModel>;
};
/**
 * Request parameters for apiV1CountriesCountryIdDelete operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdDeleteRequest
 */
export interface CountriesApiApiV1CountriesCountryIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdDelete
     */
    readonly countryId: string;
    /**
     * Admin only
     * @type {boolean}
     * @memberof CountriesApiApiV1CountriesCountryIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1CountriesCountryIdGet operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdGetRequest
 */
export interface CountriesApiApiV1CountriesCountryIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdGet
     */
    readonly countryId: string;
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof CountriesApiApiV1CountriesCountryIdGet
     */
    readonly returnDefaultValue?: boolean;
}
/**
 * Request parameters for apiV1CountriesCountryIdMediasGet operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdMediasGetRequest
 */
export interface CountriesApiApiV1CountriesCountryIdMediasGetRequest {
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasGet
     */
    readonly countryId: string;
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasGet
     */
    readonly id?: string;
    /**
     *
     * @type {MediaType}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasGet
     */
    readonly mediaType?: MediaType;
    /**
     *
     * @type {number}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1CountriesCountryIdMediasMediaIdDelete operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdMediasMediaIdDeleteRequest
 */
export interface CountriesApiApiV1CountriesCountryIdMediasMediaIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasMediaIdDelete
     */
    readonly countryId: string;
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasMediaIdDelete
     */
    readonly mediaId: string;
}
/**
 * Request parameters for apiV1CountriesCountryIdMediasMediaIdGet operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdMediasMediaIdGetRequest
 */
export interface CountriesApiApiV1CountriesCountryIdMediasMediaIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasMediaIdGet
     */
    readonly countryId: string;
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasMediaIdGet
     */
    readonly mediaId: string;
}
/**
 * Request parameters for apiV1CountriesCountryIdMediasMediaIdPut operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdMediasMediaIdPutRequest
 */
export interface CountriesApiApiV1CountriesCountryIdMediasMediaIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasMediaIdPut
     */
    readonly countryId: string;
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasMediaIdPut
     */
    readonly mediaId: string;
    /**
     *
     * @type {UpdateMediaCommand}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasMediaIdPut
     */
    readonly updateMediaCommand?: UpdateMediaCommand;
}
/**
 * Request parameters for apiV1CountriesCountryIdMediasPost operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdMediasPostRequest
 */
export interface CountriesApiApiV1CountriesCountryIdMediasPostRequest {
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasPost
     */
    readonly countryId: string;
    /**
     *
     * @type {CreateMediaCommand}
     * @memberof CountriesApiApiV1CountriesCountryIdMediasPost
     */
    readonly createMediaCommand?: CreateMediaCommand;
}
/**
 * Request parameters for apiV1CountriesCountryIdPut operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdPutRequest
 */
export interface CountriesApiApiV1CountriesCountryIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdPut
     */
    readonly countryId: string;
    /**
     *
     * @type {UpdateCountryCommand}
     * @memberof CountriesApiApiV1CountriesCountryIdPut
     */
    readonly updateCountryCommand?: UpdateCountryCommand;
}
/**
 * Request parameters for apiV1CountriesCountryIdReactivatePut operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdReactivatePutRequest
 */
export interface CountriesApiApiV1CountriesCountryIdReactivatePutRequest {
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdReactivatePut
     */
    readonly countryId: string;
}
/**
 * Request parameters for apiV1CountriesCountryIdRevalidatePost operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdRevalidatePostRequest
 */
export interface CountriesApiApiV1CountriesCountryIdRevalidatePostRequest {
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdRevalidatePost
     */
    readonly countryId: string;
    /**
     *
     * @type {boolean}
     * @memberof CountriesApiApiV1CountriesCountryIdRevalidatePost
     */
    readonly includeCurrent?: boolean;
}
/**
 * Request parameters for apiV1CountriesCountryIdTranslatePost operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesCountryIdTranslatePostRequest
 */
export interface CountriesApiApiV1CountriesCountryIdTranslatePostRequest {
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesCountryIdTranslatePost
     */
    readonly countryId: string;
    /**
     *
     * @type {TranslateCountryCommand}
     * @memberof CountriesApiApiV1CountriesCountryIdTranslatePost
     */
    readonly translateCountryCommand?: TranslateCountryCommand;
}
/**
 * Request parameters for apiV1CountriesGet operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesGetRequest
 */
export interface CountriesApiApiV1CountriesGetRequest {
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly name?: string;
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly description?: string;
    /**
     *
     * @type {Date}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly createdDate?: Date;
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof CountriesApiApiV1CountriesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1CountriesPost operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesPostRequest
 */
export interface CountriesApiApiV1CountriesPostRequest {
    /**
     *
     * @type {CreateCountryCommand}
     * @memberof CountriesApiApiV1CountriesPost
     */
    readonly createCountryCommand?: CreateCountryCommand;
}
/**
 * Request parameters for apiV1CountriesSlugGet operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesSlugGetRequest
 */
export interface CountriesApiApiV1CountriesSlugGetRequest {
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesSlugGet
     */
    readonly slug: string;
    /**
     *
     * @type {string}
     * @memberof CountriesApiApiV1CountriesSlugGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof CountriesApiApiV1CountriesSlugGet
     */
    readonly returnDefaultValue?: boolean;
}
/**
 * Request parameters for apiV1CountriesSortPut operation in CountriesApi.
 * @export
 * @interface CountriesApiApiV1CountriesSortPutRequest
 */
export interface CountriesApiApiV1CountriesSortPutRequest {
    /**
     *
     * @type {CountrySortingCommand}
     * @memberof CountriesApiApiV1CountriesSortPut
     */
    readonly countrySortingCommand?: CountrySortingCommand;
}
/**
 * CountriesApi - object-oriented interface
 * @export
 * @class CountriesApi
 * @extends {BaseAPI}
 */
export declare class CountriesApi extends BaseAPI {
    /**
     *
     * @summary Delete country.
     * @param {CountriesApiApiV1CountriesCountryIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesCountryIdDelete(requestParameters: CountriesApiApiV1CountriesCountryIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get country.
     * @param {CountriesApiApiV1CountriesCountryIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesCountryIdGet(requestParameters: CountriesApiApiV1CountriesCountryIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CountryModel, any>>;
    /**
     *
     * @summary Get all CountryMedias.
     * @param {CountriesApiApiV1CountriesCountryIdMediasGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesCountryIdMediasGet(requestParameters: CountriesApiApiV1CountriesCountryIdMediasGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediasModel, any>>;
    /**
     *
     * @summary Delete CountryMedia
     * @param {CountriesApiApiV1CountriesCountryIdMediasMediaIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesCountryIdMediasMediaIdDelete(requestParameters: CountriesApiApiV1CountriesCountryIdMediasMediaIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get CountryMedia.
     * @param {CountriesApiApiV1CountriesCountryIdMediasMediaIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesCountryIdMediasMediaIdGet(requestParameters: CountriesApiApiV1CountriesCountryIdMediasMediaIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediaModel, any>>;
    /**
     *
     * @summary Update CountryMedia.
     * @param {CountriesApiApiV1CountriesCountryIdMediasMediaIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesCountryIdMediasMediaIdPut(requestParameters: CountriesApiApiV1CountriesCountryIdMediasMediaIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediaModel, any>>;
    /**
     *
     * @summary Create CountryMedia.
     * @param {CountriesApiApiV1CountriesCountryIdMediasPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesCountryIdMediasPost(requestParameters: CountriesApiApiV1CountriesCountryIdMediasPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediaModel, any>>;
    /**
     *
     * @summary Update country.
     * @param {CountriesApiApiV1CountriesCountryIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesCountryIdPut(requestParameters: CountriesApiApiV1CountriesCountryIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CountryModel, any>>;
    /**
     *
     * @summary Reactivate country.
     * @param {CountriesApiApiV1CountriesCountryIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesCountryIdReactivatePut(requestParameters: CountriesApiApiV1CountriesCountryIdReactivatePutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Revalidate country
     * @param {CountriesApiApiV1CountriesCountryIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesCountryIdRevalidatePost(requestParameters: CountriesApiApiV1CountriesCountryIdRevalidatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Translate country
     * @param {CountriesApiApiV1CountriesCountryIdTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesCountryIdTranslatePost(requestParameters: CountriesApiApiV1CountriesCountryIdTranslatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get all countries.
     * @param {CountriesApiApiV1CountriesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesGet(requestParameters?: CountriesApiApiV1CountriesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CountriesModel, any>>;
    /**
     *
     * @summary Create a country.
     * @param {CountriesApiApiV1CountriesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesPost(requestParameters?: CountriesApiApiV1CountriesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CountryModel, any>>;
    /**
     *
     * @summary Get country by slug
     * @param {CountriesApiApiV1CountriesSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesSlugGet(requestParameters: CountriesApiApiV1CountriesSlugGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CountryModel, any>>;
    /**
     *
     * @summary Batch for countries sorting
     * @param {CountriesApiApiV1CountriesSortPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CountriesApi
     */
    apiV1CountriesSortPut(requestParameters?: CountriesApiApiV1CountriesSortPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SortingResultModel, any>>;
}
//# sourceMappingURL=countries-api.d.ts.map