/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateMediaCommand } from '../models';
import { CreateServiceReviewCommand } from '../models';
import { Gender } from '../models';
import { MediaModel } from '../models';
import { MediaType } from '../models';
import { MediasModel } from '../models';
import { ReviewType } from '../models';
import { ServiceReviewModel } from '../models';
import { ServiceReviewsModel } from '../models';
import { UpdateMediaCommand } from '../models';
import { UpdateServiceReviewCommand } from '../models';
/**
 * ServiceReviewsApi - axios parameter creator
 * @export
 */
export declare const ServiceReviewsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all ServiceReviews.
     * @param {string} [id]
     * @param {string} [serviceId]
     * @param {string} [serviceName]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [patientId]
     * @param {string} [patientName]
     * @param {Gender} [gender]
     * @param {boolean} [recommended]
     * @param {number} [rate]
     * @param {ReviewType} [reviewType]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsGet: (id?: string, serviceId?: string, serviceName?: string, hospitalId?: string, hospitalName?: string, patientId?: string, patientName?: string, gender?: Gender, recommended?: boolean, rate?: number, reviewType?: ReviewType, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a ServiceReview.
     * @param {CreateServiceReviewCommand} [createServiceReviewCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsPost: (createServiceReviewCommand?: CreateServiceReviewCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete ServiceReview.
     * @param {string} serviceReviewId
     * @param {string} [languageCode]
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdDelete: (serviceReviewId: string, languageCode?: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary
     * @param {string} serviceReviewId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdGet: (serviceReviewId: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all ServiceReviewMedias.
     * @param {string} serviceReviewId
     * @param {string} [id]
     * @param {MediaType} [mediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasGet: (serviceReviewId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete ServiceReviewMedia
     * @param {string} serviceReviewId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete: (serviceReviewId: string, mediaId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get ServiceReviewMedia.
     * @param {string} serviceReviewId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasMediaIdGet: (serviceReviewId: string, mediaId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update ServiceReviewMedia.
     * @param {string} serviceReviewId
     * @param {string} mediaId
     * @param {UpdateMediaCommand} [updateMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasMediaIdPut: (serviceReviewId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create ServiceReviewMedia.
     * @param {string} serviceReviewId
     * @param {CreateMediaCommand} [createMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasPost: (serviceReviewId: string, createMediaCommand?: CreateMediaCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update ServiceReview.
     * @param {string} serviceReviewId
     * @param {UpdateServiceReviewCommand} [updateServiceReviewCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdPut: (serviceReviewId: string, updateServiceReviewCommand?: UpdateServiceReviewCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * ServiceReviewsApi - functional programming interface
 * @export
 */
export declare const ServiceReviewsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all ServiceReviews.
     * @param {string} [id]
     * @param {string} [serviceId]
     * @param {string} [serviceName]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [patientId]
     * @param {string} [patientName]
     * @param {Gender} [gender]
     * @param {boolean} [recommended]
     * @param {number} [rate]
     * @param {ReviewType} [reviewType]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsGet(id?: string, serviceId?: string, serviceName?: string, hospitalId?: string, hospitalName?: string, patientId?: string, patientName?: string, gender?: Gender, recommended?: boolean, rate?: number, reviewType?: ReviewType, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceReviewsModel>>;
    /**
     *
     * @summary Create a ServiceReview.
     * @param {CreateServiceReviewCommand} [createServiceReviewCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsPost(createServiceReviewCommand?: CreateServiceReviewCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceReviewModel>>;
    /**
     *
     * @summary Delete ServiceReview.
     * @param {string} serviceReviewId
     * @param {string} [languageCode]
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdDelete(serviceReviewId: string, languageCode?: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary
     * @param {string} serviceReviewId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdGet(serviceReviewId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceReviewModel>>;
    /**
     *
     * @summary Get all ServiceReviewMedias.
     * @param {string} serviceReviewId
     * @param {string} [id]
     * @param {MediaType} [mediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasGet(serviceReviewId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediasModel>>;
    /**
     *
     * @summary Delete ServiceReviewMedia
     * @param {string} serviceReviewId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete(serviceReviewId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get ServiceReviewMedia.
     * @param {string} serviceReviewId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasMediaIdGet(serviceReviewId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>>;
    /**
     *
     * @summary Update ServiceReviewMedia.
     * @param {string} serviceReviewId
     * @param {string} mediaId
     * @param {UpdateMediaCommand} [updateMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasMediaIdPut(serviceReviewId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>>;
    /**
     *
     * @summary Create ServiceReviewMedia.
     * @param {string} serviceReviewId
     * @param {CreateMediaCommand} [createMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasPost(serviceReviewId: string, createMediaCommand?: CreateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>>;
    /**
     *
     * @summary Update ServiceReview.
     * @param {string} serviceReviewId
     * @param {UpdateServiceReviewCommand} [updateServiceReviewCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdPut(serviceReviewId: string, updateServiceReviewCommand?: UpdateServiceReviewCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceReviewModel>>;
};
/**
 * ServiceReviewsApi - factory interface
 * @export
 */
export declare const ServiceReviewsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get all ServiceReviews.
     * @param {string} [id]
     * @param {string} [serviceId]
     * @param {string} [serviceName]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [patientId]
     * @param {string} [patientName]
     * @param {Gender} [gender]
     * @param {boolean} [recommended]
     * @param {number} [rate]
     * @param {ReviewType} [reviewType]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsGet(id?: string, serviceId?: string, serviceName?: string, hospitalId?: string, hospitalName?: string, patientId?: string, patientName?: string, gender?: Gender, recommended?: boolean, rate?: number, reviewType?: ReviewType, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<ServiceReviewsModel>;
    /**
     *
     * @summary Create a ServiceReview.
     * @param {CreateServiceReviewCommand} [createServiceReviewCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsPost(createServiceReviewCommand?: CreateServiceReviewCommand, options?: any): AxiosPromise<ServiceReviewModel>;
    /**
     *
     * @summary Delete ServiceReview.
     * @param {string} serviceReviewId
     * @param {string} [languageCode]
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdDelete(serviceReviewId: string, languageCode?: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary
     * @param {string} serviceReviewId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdGet(serviceReviewId: string, languageCode?: string, options?: any): AxiosPromise<ServiceReviewModel>;
    /**
     *
     * @summary Get all ServiceReviewMedias.
     * @param {string} serviceReviewId
     * @param {string} [id]
     * @param {MediaType} [mediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasGet(serviceReviewId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<MediasModel>;
    /**
     *
     * @summary Delete ServiceReviewMedia
     * @param {string} serviceReviewId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete(serviceReviewId: string, mediaId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get ServiceReviewMedia.
     * @param {string} serviceReviewId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasMediaIdGet(serviceReviewId: string, mediaId: string, options?: any): AxiosPromise<MediaModel>;
    /**
     *
     * @summary Update ServiceReviewMedia.
     * @param {string} serviceReviewId
     * @param {string} mediaId
     * @param {UpdateMediaCommand} [updateMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasMediaIdPut(serviceReviewId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: any): AxiosPromise<MediaModel>;
    /**
     *
     * @summary Create ServiceReviewMedia.
     * @param {string} serviceReviewId
     * @param {CreateMediaCommand} [createMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdMediasPost(serviceReviewId: string, createMediaCommand?: CreateMediaCommand, options?: any): AxiosPromise<MediaModel>;
    /**
     *
     * @summary Update ServiceReview.
     * @param {string} serviceReviewId
     * @param {UpdateServiceReviewCommand} [updateServiceReviewCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicereviewsServiceReviewIdPut(serviceReviewId: string, updateServiceReviewCommand?: UpdateServiceReviewCommand, options?: any): AxiosPromise<ServiceReviewModel>;
};
/**
 * Request parameters for apiV1ServicereviewsGet operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsGetRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsGetRequest {
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly serviceId?: string;
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly serviceName?: string;
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly hospitalName?: string;
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly patientId?: string;
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly patientName?: string;
    /**
     *
     * @type {Gender}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly gender?: Gender;
    /**
     *
     * @type {boolean}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly recommended?: boolean;
    /**
     *
     * @type {number}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly rate?: number;
    /**
     *
     * @type {ReviewType}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly reviewType?: ReviewType;
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1ServicereviewsPost operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsPostRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsPostRequest {
    /**
     *
     * @type {CreateServiceReviewCommand}
     * @memberof ServiceReviewsApiApiV1ServicereviewsPost
     */
    readonly createServiceReviewCommand?: CreateServiceReviewCommand;
}
/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdDelete operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdDeleteRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdDelete
     */
    readonly serviceReviewId: string;
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdDelete
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdGet operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdGetRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdGet
     */
    readonly serviceReviewId: string;
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdGet
     */
    readonly languageCode?: string;
}
/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdMediasGet operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGetRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGetRequest {
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGet
     */
    readonly serviceReviewId: string;
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGet
     */
    readonly id?: string;
    /**
     *
     * @type {MediaType}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGet
     */
    readonly mediaType?: MediaType;
    /**
     *
     * @type {number}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdDeleteRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdDelete
     */
    readonly serviceReviewId: string;
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdDelete
     */
    readonly mediaId: string;
}
/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdMediasMediaIdGet operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdGetRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdGet
     */
    readonly serviceReviewId: string;
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdGet
     */
    readonly mediaId: string;
}
/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdMediasMediaIdPut operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdPutRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdPut
     */
    readonly serviceReviewId: string;
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdPut
     */
    readonly mediaId: string;
    /**
     *
     * @type {UpdateMediaCommand}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdPut
     */
    readonly updateMediaCommand?: UpdateMediaCommand;
}
/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdMediasPost operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasPostRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasPostRequest {
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasPost
     */
    readonly serviceReviewId: string;
    /**
     *
     * @type {CreateMediaCommand}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasPost
     */
    readonly createMediaCommand?: CreateMediaCommand;
}
/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdPut operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdPutRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdPut
     */
    readonly serviceReviewId: string;
    /**
     *
     * @type {UpdateServiceReviewCommand}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdPut
     */
    readonly updateServiceReviewCommand?: UpdateServiceReviewCommand;
}
/**
 * ServiceReviewsApi - object-oriented interface
 * @export
 * @class ServiceReviewsApi
 * @extends {BaseAPI}
 */
export declare class ServiceReviewsApi extends BaseAPI {
    /**
     *
     * @summary Get all ServiceReviews.
     * @param {ServiceReviewsApiApiV1ServicereviewsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    apiV1ServicereviewsGet(requestParameters?: ServiceReviewsApiApiV1ServicereviewsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ServiceReviewsModel, any>>;
    /**
     *
     * @summary Create a ServiceReview.
     * @param {ServiceReviewsApiApiV1ServicereviewsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    apiV1ServicereviewsPost(requestParameters?: ServiceReviewsApiApiV1ServicereviewsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ServiceReviewModel, any>>;
    /**
     *
     * @summary Delete ServiceReview.
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    apiV1ServicereviewsServiceReviewIdDelete(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    apiV1ServicereviewsServiceReviewIdGet(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ServiceReviewModel, any>>;
    /**
     *
     * @summary Get all ServiceReviewMedias.
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    apiV1ServicereviewsServiceReviewIdMediasGet(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediasModel, any>>;
    /**
     *
     * @summary Delete ServiceReviewMedia
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get ServiceReviewMedia.
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    apiV1ServicereviewsServiceReviewIdMediasMediaIdGet(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediaModel, any>>;
    /**
     *
     * @summary Update ServiceReviewMedia.
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    apiV1ServicereviewsServiceReviewIdMediasMediaIdPut(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediaModel, any>>;
    /**
     *
     * @summary Create ServiceReviewMedia.
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    apiV1ServicereviewsServiceReviewIdMediasPost(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediaModel, any>>;
    /**
     *
     * @summary Update ServiceReview.
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    apiV1ServicereviewsServiceReviewIdPut(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ServiceReviewModel, any>>;
}
//# sourceMappingURL=service-reviews-api.d.ts.map