/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { AboutUsPageModel } from '../models';
// @ts-ignore
import { AboutUsPagesModel } from '../models';
// @ts-ignore
import { CreateAboutUsPageCommand } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { TranslateAboutUsPageCommand } from '../models';
// @ts-ignore
import { UpdateAboutUsPageCommand } from '../models';
/**
 * AboutUsApi - axios parameter creator
 * @export
 */
export const AboutUsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all AboutUsList.
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [hospitalSlug] 
         * @param {string} [name] 
         * @param {boolean} [returnDefaultValue] 
         * @param {boolean} [confirmed] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AboutusGet: async (hospitalId?: string, hospitalName?: string, hospitalSlug?: string, name?: string, returnDefaultValue?: boolean, confirmed?: boolean, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/aboutus`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (hospitalName !== undefined) {
                localVarQueryParameter['HospitalName'] = hospitalName;
            }

            if (hospitalSlug !== undefined) {
                localVarQueryParameter['HospitalSlug'] = hospitalSlug;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['ReturnDefaultValue'] = returnDefaultValue;
            }

            if (confirmed !== undefined) {
                localVarQueryParameter['Confirmed'] = confirmed;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete AboutUs.
         * @param {string} hospitalId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AboutusHospitalIdDelete: async (hospitalId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1AboutusHospitalIdDelete', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/aboutus/{hospitalId}`
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get AboutUs.
         * @param {string} hospitalId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AboutusHospitalIdGet: async (hospitalId: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1AboutusHospitalIdGet', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/aboutus/{hospitalId}`
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update AboutUs.
         * @param {string} hospitalId 
         * @param {UpdateAboutUsPageCommand} [updateAboutUsPageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AboutusHospitalIdPut: async (hospitalId: string, updateAboutUsPageCommand?: UpdateAboutUsPageCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1AboutusHospitalIdPut', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/aboutus/{hospitalId}`
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateAboutUsPageCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Translate aboutUsPage
         * @param {string} hospitalId 
         * @param {TranslateAboutUsPageCommand} [translateAboutUsPageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AboutusHospitalIdTranslatePost: async (hospitalId: string, translateAboutUsPageCommand?: TranslateAboutUsPageCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1AboutusHospitalIdTranslatePost', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/aboutus/{hospitalId}/translate`
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(translateAboutUsPageCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create AboutUs.
         * @param {CreateAboutUsPageCommand} [createAboutUsPageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AboutusPost: async (createAboutUsPageCommand?: CreateAboutUsPageCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/aboutus`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createAboutUsPageCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary 
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AboutusSlugGet: async (slug: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'slug' is not null or undefined
            assertParamExists('apiV1AboutusSlugGet', 'slug', slug)
            const localVarPath = `/api/v1/aboutus/{slug}`
                .replace(`{${"slug"}}`, encodeURIComponent(String(slug)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AboutUsApi - functional programming interface
 * @export
 */
export const AboutUsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = AboutUsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all AboutUsList.
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [hospitalSlug] 
         * @param {string} [name] 
         * @param {boolean} [returnDefaultValue] 
         * @param {boolean} [confirmed] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AboutusGet(hospitalId?: string, hospitalName?: string, hospitalSlug?: string, name?: string, returnDefaultValue?: boolean, confirmed?: boolean, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AboutUsPagesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AboutusGet(hospitalId, hospitalName, hospitalSlug, name, returnDefaultValue, confirmed, languageCode, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete AboutUs.
         * @param {string} hospitalId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AboutusHospitalIdDelete(hospitalId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AboutusHospitalIdDelete(hospitalId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get AboutUs.
         * @param {string} hospitalId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AboutusHospitalIdGet(hospitalId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AboutUsPageModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AboutusHospitalIdGet(hospitalId, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update AboutUs.
         * @param {string} hospitalId 
         * @param {UpdateAboutUsPageCommand} [updateAboutUsPageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AboutusHospitalIdPut(hospitalId: string, updateAboutUsPageCommand?: UpdateAboutUsPageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AboutUsPageModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AboutusHospitalIdPut(hospitalId, updateAboutUsPageCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Translate aboutUsPage
         * @param {string} hospitalId 
         * @param {TranslateAboutUsPageCommand} [translateAboutUsPageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AboutusHospitalIdTranslatePost(hospitalId: string, translateAboutUsPageCommand?: TranslateAboutUsPageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AboutusHospitalIdTranslatePost(hospitalId, translateAboutUsPageCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create AboutUs.
         * @param {CreateAboutUsPageCommand} [createAboutUsPageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AboutusPost(createAboutUsPageCommand?: CreateAboutUsPageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AboutUsPageModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AboutusPost(createAboutUsPageCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary 
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AboutusSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AboutUsPageModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AboutusSlugGet(slug, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * AboutUsApi - factory interface
 * @export
 */
export const AboutUsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = AboutUsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all AboutUsList.
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [hospitalSlug] 
         * @param {string} [name] 
         * @param {boolean} [returnDefaultValue] 
         * @param {boolean} [confirmed] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AboutusGet(hospitalId?: string, hospitalName?: string, hospitalSlug?: string, name?: string, returnDefaultValue?: boolean, confirmed?: boolean, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<AboutUsPagesModel> {
            return localVarFp.apiV1AboutusGet(hospitalId, hospitalName, hospitalSlug, name, returnDefaultValue, confirmed, languageCode, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete AboutUs.
         * @param {string} hospitalId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AboutusHospitalIdDelete(hospitalId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1AboutusHospitalIdDelete(hospitalId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get AboutUs.
         * @param {string} hospitalId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AboutusHospitalIdGet(hospitalId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<AboutUsPageModel> {
            return localVarFp.apiV1AboutusHospitalIdGet(hospitalId, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update AboutUs.
         * @param {string} hospitalId 
         * @param {UpdateAboutUsPageCommand} [updateAboutUsPageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AboutusHospitalIdPut(hospitalId: string, updateAboutUsPageCommand?: UpdateAboutUsPageCommand, options?: any): AxiosPromise<AboutUsPageModel> {
            return localVarFp.apiV1AboutusHospitalIdPut(hospitalId, updateAboutUsPageCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Translate aboutUsPage
         * @param {string} hospitalId 
         * @param {TranslateAboutUsPageCommand} [translateAboutUsPageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AboutusHospitalIdTranslatePost(hospitalId: string, translateAboutUsPageCommand?: TranslateAboutUsPageCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1AboutusHospitalIdTranslatePost(hospitalId, translateAboutUsPageCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create AboutUs.
         * @param {CreateAboutUsPageCommand} [createAboutUsPageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AboutusPost(createAboutUsPageCommand?: CreateAboutUsPageCommand, options?: any): AxiosPromise<AboutUsPageModel> {
            return localVarFp.apiV1AboutusPost(createAboutUsPageCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary 
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AboutusSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<AboutUsPageModel> {
            return localVarFp.apiV1AboutusSlugGet(slug, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1AboutusGet operation in AboutUsApi.
 * @export
 * @interface AboutUsApiApiV1AboutusGetRequest
 */
export interface AboutUsApiApiV1AboutusGetRequest {
    /**
     * 
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly hospitalName?: string

    /**
     * 
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly hospitalSlug?: string

    /**
     * 
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly name?: string

    /**
     * 
     * @type {boolean}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly returnDefaultValue?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly confirmed?: boolean

    /**
     * 
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1AboutusHospitalIdDelete operation in AboutUsApi.
 * @export
 * @interface AboutUsApiApiV1AboutusHospitalIdDeleteRequest
 */
export interface AboutUsApiApiV1AboutusHospitalIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusHospitalIdDelete
     */
    readonly hospitalId: string

    /**
     * 
     * @type {boolean}
     * @memberof AboutUsApiApiV1AboutusHospitalIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1AboutusHospitalIdGet operation in AboutUsApi.
 * @export
 * @interface AboutUsApiApiV1AboutusHospitalIdGetRequest
 */
export interface AboutUsApiApiV1AboutusHospitalIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusHospitalIdGet
     */
    readonly hospitalId: string

    /**
     * 
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusHospitalIdGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof AboutUsApiApiV1AboutusHospitalIdGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * Request parameters for apiV1AboutusHospitalIdPut operation in AboutUsApi.
 * @export
 * @interface AboutUsApiApiV1AboutusHospitalIdPutRequest
 */
export interface AboutUsApiApiV1AboutusHospitalIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusHospitalIdPut
     */
    readonly hospitalId: string

    /**
     * 
     * @type {UpdateAboutUsPageCommand}
     * @memberof AboutUsApiApiV1AboutusHospitalIdPut
     */
    readonly updateAboutUsPageCommand?: UpdateAboutUsPageCommand
}

/**
 * Request parameters for apiV1AboutusHospitalIdTranslatePost operation in AboutUsApi.
 * @export
 * @interface AboutUsApiApiV1AboutusHospitalIdTranslatePostRequest
 */
export interface AboutUsApiApiV1AboutusHospitalIdTranslatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusHospitalIdTranslatePost
     */
    readonly hospitalId: string

    /**
     * 
     * @type {TranslateAboutUsPageCommand}
     * @memberof AboutUsApiApiV1AboutusHospitalIdTranslatePost
     */
    readonly translateAboutUsPageCommand?: TranslateAboutUsPageCommand
}

/**
 * Request parameters for apiV1AboutusPost operation in AboutUsApi.
 * @export
 * @interface AboutUsApiApiV1AboutusPostRequest
 */
export interface AboutUsApiApiV1AboutusPostRequest {
    /**
     * 
     * @type {CreateAboutUsPageCommand}
     * @memberof AboutUsApiApiV1AboutusPost
     */
    readonly createAboutUsPageCommand?: CreateAboutUsPageCommand
}

/**
 * Request parameters for apiV1AboutusSlugGet operation in AboutUsApi.
 * @export
 * @interface AboutUsApiApiV1AboutusSlugGetRequest
 */
export interface AboutUsApiApiV1AboutusSlugGetRequest {
    /**
     * 
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusSlugGet
     */
    readonly slug: string

    /**
     * 
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusSlugGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof AboutUsApiApiV1AboutusSlugGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * AboutUsApi - object-oriented interface
 * @export
 * @class AboutUsApi
 * @extends {BaseAPI}
 */
export class AboutUsApi extends BaseAPI {
    /**
     * 
     * @summary Get all AboutUsList.
     * @param {AboutUsApiApiV1AboutusGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AboutUsApi
     */
    public apiV1AboutusGet(requestParameters: AboutUsApiApiV1AboutusGetRequest = {}, options?: AxiosRequestConfig) {
        return AboutUsApiFp(this.configuration).apiV1AboutusGet(requestParameters.hospitalId, requestParameters.hospitalName, requestParameters.hospitalSlug, requestParameters.name, requestParameters.returnDefaultValue, requestParameters.confirmed, requestParameters.languageCode, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete AboutUs.
     * @param {AboutUsApiApiV1AboutusHospitalIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AboutUsApi
     */
    public apiV1AboutusHospitalIdDelete(requestParameters: AboutUsApiApiV1AboutusHospitalIdDeleteRequest, options?: AxiosRequestConfig) {
        return AboutUsApiFp(this.configuration).apiV1AboutusHospitalIdDelete(requestParameters.hospitalId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get AboutUs.
     * @param {AboutUsApiApiV1AboutusHospitalIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AboutUsApi
     */
    public apiV1AboutusHospitalIdGet(requestParameters: AboutUsApiApiV1AboutusHospitalIdGetRequest, options?: AxiosRequestConfig) {
        return AboutUsApiFp(this.configuration).apiV1AboutusHospitalIdGet(requestParameters.hospitalId, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update AboutUs.
     * @param {AboutUsApiApiV1AboutusHospitalIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AboutUsApi
     */
    public apiV1AboutusHospitalIdPut(requestParameters: AboutUsApiApiV1AboutusHospitalIdPutRequest, options?: AxiosRequestConfig) {
        return AboutUsApiFp(this.configuration).apiV1AboutusHospitalIdPut(requestParameters.hospitalId, requestParameters.updateAboutUsPageCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Translate aboutUsPage
     * @param {AboutUsApiApiV1AboutusHospitalIdTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AboutUsApi
     */
    public apiV1AboutusHospitalIdTranslatePost(requestParameters: AboutUsApiApiV1AboutusHospitalIdTranslatePostRequest, options?: AxiosRequestConfig) {
        return AboutUsApiFp(this.configuration).apiV1AboutusHospitalIdTranslatePost(requestParameters.hospitalId, requestParameters.translateAboutUsPageCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create AboutUs.
     * @param {AboutUsApiApiV1AboutusPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AboutUsApi
     */
    public apiV1AboutusPost(requestParameters: AboutUsApiApiV1AboutusPostRequest = {}, options?: AxiosRequestConfig) {
        return AboutUsApiFp(this.configuration).apiV1AboutusPost(requestParameters.createAboutUsPageCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary 
     * @param {AboutUsApiApiV1AboutusSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AboutUsApi
     */
    public apiV1AboutusSlugGet(requestParameters: AboutUsApiApiV1AboutusSlugGetRequest, options?: AxiosRequestConfig) {
        return AboutUsApiFp(this.configuration).apiV1AboutusSlugGet(requestParameters.slug, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }
}
