/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CommunicationUserTokenModel } from '../models';
/**
 * CommunicationsApi - axios parameter creator
 * @export
 */
export const CommunicationsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete CommunicationUser.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CommunicationsDelete: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/communications`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get CommunicationUser.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CommunicationsGet: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/communications`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Revoke CommunicationUser.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CommunicationsPut: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/communications`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CommunicationsApi - functional programming interface
 * @export
 */
export const CommunicationsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = CommunicationsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete CommunicationUser.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CommunicationsDelete(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<number>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CommunicationsDelete(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get CommunicationUser.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CommunicationsGet(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CommunicationUserTokenModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CommunicationsGet(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Revoke CommunicationUser.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CommunicationsPut(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CommunicationUserTokenModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CommunicationsPut(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * CommunicationsApi - factory interface
 * @export
 */
export const CommunicationsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = CommunicationsApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete CommunicationUser.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CommunicationsDelete(options?: any): AxiosPromise<number> {
            return localVarFp.apiV1CommunicationsDelete(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get CommunicationUser.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CommunicationsGet(options?: any): AxiosPromise<CommunicationUserTokenModel> {
            return localVarFp.apiV1CommunicationsGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Revoke CommunicationUser.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CommunicationsPut(options?: any): AxiosPromise<CommunicationUserTokenModel> {
            return localVarFp.apiV1CommunicationsPut(options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * CommunicationsApi - object-oriented interface
 * @export
 * @class CommunicationsApi
 * @extends {BaseAPI}
 */
export class CommunicationsApi extends BaseAPI {
    /**
     * 
     * @summary Delete CommunicationUser.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CommunicationsApi
     */
    public apiV1CommunicationsDelete(options?: AxiosRequestConfig) {
        return CommunicationsApiFp(this.configuration).apiV1CommunicationsDelete(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get CommunicationUser.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CommunicationsApi
     */
    public apiV1CommunicationsGet(options?: AxiosRequestConfig) {
        return CommunicationsApiFp(this.configuration).apiV1CommunicationsGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Revoke CommunicationUser.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CommunicationsApi
     */
    public apiV1CommunicationsPut(options?: AxiosRequestConfig) {
        return CommunicationsApiFp(this.configuration).apiV1CommunicationsPut(options).then((request) => request(this.axios, this.basePath));
    }
}
