/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { AddHospitalIntoBranchCommand } from '../models';
// @ts-ignore
import { CreateHospitalBranchCommand } from '../models';
// @ts-ignore
import { HospitalBranchModel } from '../models';
// @ts-ignore
import { HospitalBranchesModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateHospitalBranchCommand } from '../models';
// @ts-ignore
import { UpdateHospitalBranchItemCommand } from '../models';
/**
 * HospitalBranchesApi - axios parameter creator
 * @export
 */
export const HospitalBranchesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get hospitalBranches
         * @param {string} [id] 
         * @param {string} [hospitalGroupId] 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesGet: async (id?: string, hospitalGroupId?: string, hospitalId?: string, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/hospitalbranches`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (hospitalGroupId !== undefined) {
                localVarQueryParameter['HospitalGroupId'] = hospitalGroupId;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete hospitalBranch
         * @param {string} hospitalBranchId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesHospitalBranchIdDelete: async (hospitalBranchId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalBranchId' is not null or undefined
            assertParamExists('apiV1HospitalbranchesHospitalBranchIdDelete', 'hospitalBranchId', hospitalBranchId)
            const localVarPath = `/api/v1/hospitalbranches/{hospitalBranchId}`
                .replace(`{${"hospitalBranchId"}}`, encodeURIComponent(String(hospitalBranchId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get hospitalBranch
         * @param {string} hospitalBranchId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesHospitalBranchIdGet: async (hospitalBranchId: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalBranchId' is not null or undefined
            assertParamExists('apiV1HospitalbranchesHospitalBranchIdGet', 'hospitalBranchId', hospitalBranchId)
            const localVarPath = `/api/v1/hospitalbranches/{hospitalBranchId}`
                .replace(`{${"hospitalBranchId"}}`, encodeURIComponent(String(hospitalBranchId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Remove hospital from HospitalBranch
         * @param {string} hospitalBranchId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete: async (hospitalBranchId: string, hospitalId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalBranchId' is not null or undefined
            assertParamExists('apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete', 'hospitalBranchId', hospitalBranchId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/hospitalbranches/{hospitalBranchId}/hospitals/{hospitalId}`
                .replace(`{${"hospitalBranchId"}}`, encodeURIComponent(String(hospitalBranchId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Add hospital into HospitalBranch
         * @param {string} hospitalBranchId 
         * @param {string} hospitalId 
         * @param {AddHospitalIntoBranchCommand} [addHospitalIntoBranchCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost: async (hospitalBranchId: string, hospitalId: string, addHospitalIntoBranchCommand?: AddHospitalIntoBranchCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalBranchId' is not null or undefined
            assertParamExists('apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost', 'hospitalBranchId', hospitalBranchId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/hospitalbranches/{hospitalBranchId}/hospitals/{hospitalId}`
                .replace(`{${"hospitalBranchId"}}`, encodeURIComponent(String(hospitalBranchId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(addHospitalIntoBranchCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update hospitalBranchItem
         * @param {string} hospitalBranchId 
         * @param {string} hospitalId 
         * @param {UpdateHospitalBranchItemCommand} [updateHospitalBranchItemCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut: async (hospitalBranchId: string, hospitalId: string, updateHospitalBranchItemCommand?: UpdateHospitalBranchItemCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalBranchId' is not null or undefined
            assertParamExists('apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut', 'hospitalBranchId', hospitalBranchId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/hospitalbranches/{hospitalBranchId}/hospitals/{hospitalId}`
                .replace(`{${"hospitalBranchId"}}`, encodeURIComponent(String(hospitalBranchId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateHospitalBranchItemCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update hospitalBranch
         * @param {string} hospitalBranchId 
         * @param {UpdateHospitalBranchCommand} [updateHospitalBranchCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesHospitalBranchIdPut: async (hospitalBranchId: string, updateHospitalBranchCommand?: UpdateHospitalBranchCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalBranchId' is not null or undefined
            assertParamExists('apiV1HospitalbranchesHospitalBranchIdPut', 'hospitalBranchId', hospitalBranchId)
            const localVarPath = `/api/v1/hospitalbranches/{hospitalBranchId}`
                .replace(`{${"hospitalBranchId"}}`, encodeURIComponent(String(hospitalBranchId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateHospitalBranchCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactivate hospitalBranch
         * @param {string} hospitalBranchId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesHospitalBranchIdReactivatePut: async (hospitalBranchId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalBranchId' is not null or undefined
            assertParamExists('apiV1HospitalbranchesHospitalBranchIdReactivatePut', 'hospitalBranchId', hospitalBranchId)
            const localVarPath = `/api/v1/hospitalbranches/{hospitalBranchId}/reactivate`
                .replace(`{${"hospitalBranchId"}}`, encodeURIComponent(String(hospitalBranchId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create hospitalBranch
         * @param {CreateHospitalBranchCommand} [createHospitalBranchCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesPost: async (createHospitalBranchCommand?: CreateHospitalBranchCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/hospitalbranches`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createHospitalBranchCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * HospitalBranchesApi - functional programming interface
 * @export
 */
export const HospitalBranchesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = HospitalBranchesApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get hospitalBranches
         * @param {string} [id] 
         * @param {string} [hospitalGroupId] 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalbranchesGet(id?: string, hospitalGroupId?: string, hospitalId?: string, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalBranchesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalbranchesGet(id, hospitalGroupId, hospitalId, languageCode, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete hospitalBranch
         * @param {string} hospitalBranchId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalbranchesHospitalBranchIdDelete(hospitalBranchId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalbranchesHospitalBranchIdDelete(hospitalBranchId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get hospitalBranch
         * @param {string} hospitalBranchId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalbranchesHospitalBranchIdGet(hospitalBranchId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalBranchModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalbranchesHospitalBranchIdGet(hospitalBranchId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Remove hospital from HospitalBranch
         * @param {string} hospitalBranchId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete(hospitalBranchId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete(hospitalBranchId, hospitalId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Add hospital into HospitalBranch
         * @param {string} hospitalBranchId 
         * @param {string} hospitalId 
         * @param {AddHospitalIntoBranchCommand} [addHospitalIntoBranchCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost(hospitalBranchId: string, hospitalId: string, addHospitalIntoBranchCommand?: AddHospitalIntoBranchCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalBranchModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost(hospitalBranchId, hospitalId, addHospitalIntoBranchCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update hospitalBranchItem
         * @param {string} hospitalBranchId 
         * @param {string} hospitalId 
         * @param {UpdateHospitalBranchItemCommand} [updateHospitalBranchItemCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut(hospitalBranchId: string, hospitalId: string, updateHospitalBranchItemCommand?: UpdateHospitalBranchItemCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalBranchModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut(hospitalBranchId, hospitalId, updateHospitalBranchItemCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update hospitalBranch
         * @param {string} hospitalBranchId 
         * @param {UpdateHospitalBranchCommand} [updateHospitalBranchCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalbranchesHospitalBranchIdPut(hospitalBranchId: string, updateHospitalBranchCommand?: UpdateHospitalBranchCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalBranchModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalbranchesHospitalBranchIdPut(hospitalBranchId, updateHospitalBranchCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactivate hospitalBranch
         * @param {string} hospitalBranchId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalbranchesHospitalBranchIdReactivatePut(hospitalBranchId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalbranchesHospitalBranchIdReactivatePut(hospitalBranchId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create hospitalBranch
         * @param {CreateHospitalBranchCommand} [createHospitalBranchCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalbranchesPost(createHospitalBranchCommand?: CreateHospitalBranchCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalBranchModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalbranchesPost(createHospitalBranchCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * HospitalBranchesApi - factory interface
 * @export
 */
export const HospitalBranchesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = HospitalBranchesApiFp(configuration)
    return {
        /**
         * 
         * @summary Get hospitalBranches
         * @param {string} [id] 
         * @param {string} [hospitalGroupId] 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesGet(id?: string, hospitalGroupId?: string, hospitalId?: string, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<HospitalBranchesModel> {
            return localVarFp.apiV1HospitalbranchesGet(id, hospitalGroupId, hospitalId, languageCode, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete hospitalBranch
         * @param {string} hospitalBranchId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesHospitalBranchIdDelete(hospitalBranchId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1HospitalbranchesHospitalBranchIdDelete(hospitalBranchId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get hospitalBranch
         * @param {string} hospitalBranchId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesHospitalBranchIdGet(hospitalBranchId: string, languageCode?: string, options?: any): AxiosPromise<HospitalBranchModel> {
            return localVarFp.apiV1HospitalbranchesHospitalBranchIdGet(hospitalBranchId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Remove hospital from HospitalBranch
         * @param {string} hospitalBranchId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete(hospitalBranchId: string, hospitalId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete(hospitalBranchId, hospitalId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Add hospital into HospitalBranch
         * @param {string} hospitalBranchId 
         * @param {string} hospitalId 
         * @param {AddHospitalIntoBranchCommand} [addHospitalIntoBranchCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost(hospitalBranchId: string, hospitalId: string, addHospitalIntoBranchCommand?: AddHospitalIntoBranchCommand, options?: any): AxiosPromise<HospitalBranchModel> {
            return localVarFp.apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost(hospitalBranchId, hospitalId, addHospitalIntoBranchCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update hospitalBranchItem
         * @param {string} hospitalBranchId 
         * @param {string} hospitalId 
         * @param {UpdateHospitalBranchItemCommand} [updateHospitalBranchItemCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut(hospitalBranchId: string, hospitalId: string, updateHospitalBranchItemCommand?: UpdateHospitalBranchItemCommand, options?: any): AxiosPromise<HospitalBranchModel> {
            return localVarFp.apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut(hospitalBranchId, hospitalId, updateHospitalBranchItemCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update hospitalBranch
         * @param {string} hospitalBranchId 
         * @param {UpdateHospitalBranchCommand} [updateHospitalBranchCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesHospitalBranchIdPut(hospitalBranchId: string, updateHospitalBranchCommand?: UpdateHospitalBranchCommand, options?: any): AxiosPromise<HospitalBranchModel> {
            return localVarFp.apiV1HospitalbranchesHospitalBranchIdPut(hospitalBranchId, updateHospitalBranchCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactivate hospitalBranch
         * @param {string} hospitalBranchId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesHospitalBranchIdReactivatePut(hospitalBranchId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1HospitalbranchesHospitalBranchIdReactivatePut(hospitalBranchId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create hospitalBranch
         * @param {CreateHospitalBranchCommand} [createHospitalBranchCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalbranchesPost(createHospitalBranchCommand?: CreateHospitalBranchCommand, options?: any): AxiosPromise<HospitalBranchModel> {
            return localVarFp.apiV1HospitalbranchesPost(createHospitalBranchCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1HospitalbranchesGet operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesGetRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly hospitalGroupId?: string

    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1HospitalbranchesHospitalBranchIdDelete operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdDeleteRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdDelete
     */
    readonly hospitalBranchId: string

    /**
     * 
     * @type {boolean}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1HospitalbranchesHospitalBranchIdGet operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdGetRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdGet
     */
    readonly hospitalBranchId: string

    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDeleteRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete
     */
    readonly hospitalBranchId: string

    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete
     */
    readonly hospitalId: string
}

/**
 * Request parameters for apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPostRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPostRequest {
    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost
     */
    readonly hospitalBranchId: string

    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost
     */
    readonly hospitalId: string

    /**
     * 
     * @type {AddHospitalIntoBranchCommand}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost
     */
    readonly addHospitalIntoBranchCommand?: AddHospitalIntoBranchCommand
}

/**
 * Request parameters for apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPutRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut
     */
    readonly hospitalBranchId: string

    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut
     */
    readonly hospitalId: string

    /**
     * 
     * @type {UpdateHospitalBranchItemCommand}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut
     */
    readonly updateHospitalBranchItemCommand?: UpdateHospitalBranchItemCommand
}

/**
 * Request parameters for apiV1HospitalbranchesHospitalBranchIdPut operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdPutRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdPut
     */
    readonly hospitalBranchId: string

    /**
     * 
     * @type {UpdateHospitalBranchCommand}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdPut
     */
    readonly updateHospitalBranchCommand?: UpdateHospitalBranchCommand
}

/**
 * Request parameters for apiV1HospitalbranchesHospitalBranchIdReactivatePut operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdReactivatePutRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdReactivatePut
     */
    readonly hospitalBranchId: string
}

/**
 * Request parameters for apiV1HospitalbranchesPost operation in HospitalBranchesApi.
 * @export
 * @interface HospitalBranchesApiApiV1HospitalbranchesPostRequest
 */
export interface HospitalBranchesApiApiV1HospitalbranchesPostRequest {
    /**
     * 
     * @type {CreateHospitalBranchCommand}
     * @memberof HospitalBranchesApiApiV1HospitalbranchesPost
     */
    readonly createHospitalBranchCommand?: CreateHospitalBranchCommand
}

/**
 * HospitalBranchesApi - object-oriented interface
 * @export
 * @class HospitalBranchesApi
 * @extends {BaseAPI}
 */
export class HospitalBranchesApi extends BaseAPI {
    /**
     * 
     * @summary Get hospitalBranches
     * @param {HospitalBranchesApiApiV1HospitalbranchesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    public apiV1HospitalbranchesGet(requestParameters: HospitalBranchesApiApiV1HospitalbranchesGetRequest = {}, options?: AxiosRequestConfig) {
        return HospitalBranchesApiFp(this.configuration).apiV1HospitalbranchesGet(requestParameters.id, requestParameters.hospitalGroupId, requestParameters.hospitalId, requestParameters.languageCode, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete hospitalBranch
     * @param {HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    public apiV1HospitalbranchesHospitalBranchIdDelete(requestParameters: HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdDeleteRequest, options?: AxiosRequestConfig) {
        return HospitalBranchesApiFp(this.configuration).apiV1HospitalbranchesHospitalBranchIdDelete(requestParameters.hospitalBranchId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get hospitalBranch
     * @param {HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    public apiV1HospitalbranchesHospitalBranchIdGet(requestParameters: HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdGetRequest, options?: AxiosRequestConfig) {
        return HospitalBranchesApiFp(this.configuration).apiV1HospitalbranchesHospitalBranchIdGet(requestParameters.hospitalBranchId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Remove hospital from HospitalBranch
     * @param {HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    public apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete(requestParameters: HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDeleteRequest, options?: AxiosRequestConfig) {
        return HospitalBranchesApiFp(this.configuration).apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdDelete(requestParameters.hospitalBranchId, requestParameters.hospitalId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Add hospital into HospitalBranch
     * @param {HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    public apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost(requestParameters: HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPostRequest, options?: AxiosRequestConfig) {
        return HospitalBranchesApiFp(this.configuration).apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPost(requestParameters.hospitalBranchId, requestParameters.hospitalId, requestParameters.addHospitalIntoBranchCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update hospitalBranchItem
     * @param {HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    public apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut(requestParameters: HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPutRequest, options?: AxiosRequestConfig) {
        return HospitalBranchesApiFp(this.configuration).apiV1HospitalbranchesHospitalBranchIdHospitalsHospitalIdPut(requestParameters.hospitalBranchId, requestParameters.hospitalId, requestParameters.updateHospitalBranchItemCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update hospitalBranch
     * @param {HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    public apiV1HospitalbranchesHospitalBranchIdPut(requestParameters: HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdPutRequest, options?: AxiosRequestConfig) {
        return HospitalBranchesApiFp(this.configuration).apiV1HospitalbranchesHospitalBranchIdPut(requestParameters.hospitalBranchId, requestParameters.updateHospitalBranchCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactivate hospitalBranch
     * @param {HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    public apiV1HospitalbranchesHospitalBranchIdReactivatePut(requestParameters: HospitalBranchesApiApiV1HospitalbranchesHospitalBranchIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return HospitalBranchesApiFp(this.configuration).apiV1HospitalbranchesHospitalBranchIdReactivatePut(requestParameters.hospitalBranchId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create hospitalBranch
     * @param {HospitalBranchesApiApiV1HospitalbranchesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalBranchesApi
     */
    public apiV1HospitalbranchesPost(requestParameters: HospitalBranchesApiApiV1HospitalbranchesPostRequest = {}, options?: AxiosRequestConfig) {
        return HospitalBranchesApiFp(this.configuration).apiV1HospitalbranchesPost(requestParameters.createHospitalBranchCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
