/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateHospitalGroupCommand } from '../models';
// @ts-ignore
import { HospitalGroupModel } from '../models';
// @ts-ignore
import { HospitalGroupsModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateHospitalGroupCommand } from '../models';
/**
 * HospitalGroupsApi - axios parameter creator
 * @export
 */
export const HospitalGroupsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get hospitalGroups
         * @param {string} [hospitalGroupId] 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {string} [name] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalgroupsGet: async (hospitalGroupId?: string, hospitalId?: string, languageCode?: string, name?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/hospitalgroups`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (hospitalGroupId !== undefined) {
                localVarQueryParameter['HospitalGroupId'] = hospitalGroupId;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete hospitalGroup
         * @param {string} hospitalGroupId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalgroupsHospitalGroupIdDelete: async (hospitalGroupId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalGroupId' is not null or undefined
            assertParamExists('apiV1HospitalgroupsHospitalGroupIdDelete', 'hospitalGroupId', hospitalGroupId)
            const localVarPath = `/api/v1/hospitalgroups/{hospitalGroupId}`
                .replace(`{${"hospitalGroupId"}}`, encodeURIComponent(String(hospitalGroupId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get hospitalGroup
         * @param {string} hospitalGroupId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalgroupsHospitalGroupIdGet: async (hospitalGroupId: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalGroupId' is not null or undefined
            assertParamExists('apiV1HospitalgroupsHospitalGroupIdGet', 'hospitalGroupId', hospitalGroupId)
            const localVarPath = `/api/v1/hospitalgroups/{hospitalGroupId}`
                .replace(`{${"hospitalGroupId"}}`, encodeURIComponent(String(hospitalGroupId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update hospitalGroup
         * @param {string} hospitalGroupId 
         * @param {UpdateHospitalGroupCommand} [updateHospitalGroupCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalgroupsHospitalGroupIdPut: async (hospitalGroupId: string, updateHospitalGroupCommand?: UpdateHospitalGroupCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalGroupId' is not null or undefined
            assertParamExists('apiV1HospitalgroupsHospitalGroupIdPut', 'hospitalGroupId', hospitalGroupId)
            const localVarPath = `/api/v1/hospitalgroups/{hospitalGroupId}`
                .replace(`{${"hospitalGroupId"}}`, encodeURIComponent(String(hospitalGroupId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateHospitalGroupCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactivate hospitalGroup
         * @param {string} hospitalGroupId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalgroupsHospitalGroupIdReactivatePut: async (hospitalGroupId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalGroupId' is not null or undefined
            assertParamExists('apiV1HospitalgroupsHospitalGroupIdReactivatePut', 'hospitalGroupId', hospitalGroupId)
            const localVarPath = `/api/v1/hospitalgroups/{hospitalGroupId}/reactivate`
                .replace(`{${"hospitalGroupId"}}`, encodeURIComponent(String(hospitalGroupId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create hospitalGroup
         * @param {CreateHospitalGroupCommand} [createHospitalGroupCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalgroupsPost: async (createHospitalGroupCommand?: CreateHospitalGroupCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/hospitalgroups`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createHospitalGroupCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * HospitalGroupsApi - functional programming interface
 * @export
 */
export const HospitalGroupsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = HospitalGroupsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get hospitalGroups
         * @param {string} [hospitalGroupId] 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {string} [name] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalgroupsGet(hospitalGroupId?: string, hospitalId?: string, languageCode?: string, name?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalGroupsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalgroupsGet(hospitalGroupId, hospitalId, languageCode, name, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete hospitalGroup
         * @param {string} hospitalGroupId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalgroupsHospitalGroupIdDelete(hospitalGroupId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalgroupsHospitalGroupIdDelete(hospitalGroupId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get hospitalGroup
         * @param {string} hospitalGroupId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalgroupsHospitalGroupIdGet(hospitalGroupId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalGroupModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalgroupsHospitalGroupIdGet(hospitalGroupId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update hospitalGroup
         * @param {string} hospitalGroupId 
         * @param {UpdateHospitalGroupCommand} [updateHospitalGroupCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalgroupsHospitalGroupIdPut(hospitalGroupId: string, updateHospitalGroupCommand?: UpdateHospitalGroupCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalGroupModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalgroupsHospitalGroupIdPut(hospitalGroupId, updateHospitalGroupCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactivate hospitalGroup
         * @param {string} hospitalGroupId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalgroupsHospitalGroupIdReactivatePut(hospitalGroupId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalgroupsHospitalGroupIdReactivatePut(hospitalGroupId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create hospitalGroup
         * @param {CreateHospitalGroupCommand} [createHospitalGroupCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HospitalgroupsPost(createHospitalGroupCommand?: CreateHospitalGroupCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalGroupModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HospitalgroupsPost(createHospitalGroupCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * HospitalGroupsApi - factory interface
 * @export
 */
export const HospitalGroupsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = HospitalGroupsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get hospitalGroups
         * @param {string} [hospitalGroupId] 
         * @param {string} [hospitalId] 
         * @param {string} [languageCode] 
         * @param {string} [name] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalgroupsGet(hospitalGroupId?: string, hospitalId?: string, languageCode?: string, name?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<HospitalGroupsModel> {
            return localVarFp.apiV1HospitalgroupsGet(hospitalGroupId, hospitalId, languageCode, name, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete hospitalGroup
         * @param {string} hospitalGroupId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalgroupsHospitalGroupIdDelete(hospitalGroupId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1HospitalgroupsHospitalGroupIdDelete(hospitalGroupId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get hospitalGroup
         * @param {string} hospitalGroupId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalgroupsHospitalGroupIdGet(hospitalGroupId: string, languageCode?: string, options?: any): AxiosPromise<HospitalGroupModel> {
            return localVarFp.apiV1HospitalgroupsHospitalGroupIdGet(hospitalGroupId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update hospitalGroup
         * @param {string} hospitalGroupId 
         * @param {UpdateHospitalGroupCommand} [updateHospitalGroupCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalgroupsHospitalGroupIdPut(hospitalGroupId: string, updateHospitalGroupCommand?: UpdateHospitalGroupCommand, options?: any): AxiosPromise<HospitalGroupModel> {
            return localVarFp.apiV1HospitalgroupsHospitalGroupIdPut(hospitalGroupId, updateHospitalGroupCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactivate hospitalGroup
         * @param {string} hospitalGroupId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalgroupsHospitalGroupIdReactivatePut(hospitalGroupId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1HospitalgroupsHospitalGroupIdReactivatePut(hospitalGroupId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create hospitalGroup
         * @param {CreateHospitalGroupCommand} [createHospitalGroupCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HospitalgroupsPost(createHospitalGroupCommand?: CreateHospitalGroupCommand, options?: any): AxiosPromise<HospitalGroupModel> {
            return localVarFp.apiV1HospitalgroupsPost(createHospitalGroupCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1HospitalgroupsGet operation in HospitalGroupsApi.
 * @export
 * @interface HospitalGroupsApiApiV1HospitalgroupsGetRequest
 */
export interface HospitalGroupsApiApiV1HospitalgroupsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly hospitalGroupId?: string

    /**
     * 
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly name?: string

    /**
     * 
     * @type {boolean}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1HospitalgroupsHospitalGroupIdDelete operation in HospitalGroupsApi.
 * @export
 * @interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdDeleteRequest
 */
export interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdDelete
     */
    readonly hospitalGroupId: string

    /**
     * 
     * @type {boolean}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1HospitalgroupsHospitalGroupIdGet operation in HospitalGroupsApi.
 * @export
 * @interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdGetRequest
 */
export interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdGet
     */
    readonly hospitalGroupId: string

    /**
     * 
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1HospitalgroupsHospitalGroupIdPut operation in HospitalGroupsApi.
 * @export
 * @interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdPutRequest
 */
export interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdPut
     */
    readonly hospitalGroupId: string

    /**
     * 
     * @type {UpdateHospitalGroupCommand}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdPut
     */
    readonly updateHospitalGroupCommand?: UpdateHospitalGroupCommand
}

/**
 * Request parameters for apiV1HospitalgroupsHospitalGroupIdReactivatePut operation in HospitalGroupsApi.
 * @export
 * @interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdReactivatePutRequest
 */
export interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdReactivatePut
     */
    readonly hospitalGroupId: string
}

/**
 * Request parameters for apiV1HospitalgroupsPost operation in HospitalGroupsApi.
 * @export
 * @interface HospitalGroupsApiApiV1HospitalgroupsPostRequest
 */
export interface HospitalGroupsApiApiV1HospitalgroupsPostRequest {
    /**
     * 
     * @type {CreateHospitalGroupCommand}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsPost
     */
    readonly createHospitalGroupCommand?: CreateHospitalGroupCommand
}

/**
 * HospitalGroupsApi - object-oriented interface
 * @export
 * @class HospitalGroupsApi
 * @extends {BaseAPI}
 */
export class HospitalGroupsApi extends BaseAPI {
    /**
     * 
     * @summary Get hospitalGroups
     * @param {HospitalGroupsApiApiV1HospitalgroupsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalGroupsApi
     */
    public apiV1HospitalgroupsGet(requestParameters: HospitalGroupsApiApiV1HospitalgroupsGetRequest = {}, options?: AxiosRequestConfig) {
        return HospitalGroupsApiFp(this.configuration).apiV1HospitalgroupsGet(requestParameters.hospitalGroupId, requestParameters.hospitalId, requestParameters.languageCode, requestParameters.name, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete hospitalGroup
     * @param {HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalGroupsApi
     */
    public apiV1HospitalgroupsHospitalGroupIdDelete(requestParameters: HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdDeleteRequest, options?: AxiosRequestConfig) {
        return HospitalGroupsApiFp(this.configuration).apiV1HospitalgroupsHospitalGroupIdDelete(requestParameters.hospitalGroupId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get hospitalGroup
     * @param {HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalGroupsApi
     */
    public apiV1HospitalgroupsHospitalGroupIdGet(requestParameters: HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdGetRequest, options?: AxiosRequestConfig) {
        return HospitalGroupsApiFp(this.configuration).apiV1HospitalgroupsHospitalGroupIdGet(requestParameters.hospitalGroupId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update hospitalGroup
     * @param {HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalGroupsApi
     */
    public apiV1HospitalgroupsHospitalGroupIdPut(requestParameters: HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdPutRequest, options?: AxiosRequestConfig) {
        return HospitalGroupsApiFp(this.configuration).apiV1HospitalgroupsHospitalGroupIdPut(requestParameters.hospitalGroupId, requestParameters.updateHospitalGroupCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactivate hospitalGroup
     * @param {HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalGroupsApi
     */
    public apiV1HospitalgroupsHospitalGroupIdReactivatePut(requestParameters: HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return HospitalGroupsApiFp(this.configuration).apiV1HospitalgroupsHospitalGroupIdReactivatePut(requestParameters.hospitalGroupId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create hospitalGroup
     * @param {HospitalGroupsApiApiV1HospitalgroupsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalGroupsApi
     */
    public apiV1HospitalgroupsPost(requestParameters: HospitalGroupsApiApiV1HospitalgroupsPostRequest = {}, options?: AxiosRequestConfig) {
        return HospitalGroupsApiFp(this.configuration).apiV1HospitalgroupsPost(requestParameters.createHospitalGroupCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
