/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateMediaCommand } from '../models';
// @ts-ignore
import { CreateSpecialtyCommand } from '../models';
// @ts-ignore
import { MarketingType } from '../models';
// @ts-ignore
import { MediaModel } from '../models';
// @ts-ignore
import { MediaType } from '../models';
// @ts-ignore
import { MediasModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { SpecialtiesModel } from '../models';
// @ts-ignore
import { SpecialtiesSimpleModel } from '../models';
// @ts-ignore
import { SpecialtyModel } from '../models';
// @ts-ignore
import { TranslateSpecialtyCommand } from '../models';
// @ts-ignore
import { UpdateMediaCommand } from '../models';
// @ts-ignore
import { UpdateSpecialtyCommand } from '../models';
/**
 * SpecialtiesApi - axios parameter creator
 * @export
 */
export const SpecialtiesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all Specialties.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {string} [specialtyTypeId] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [hospitalId] 
         * @param {Date} [created] 
         * @param {string} [languageCode] 
         * @param {Array<string>} [ids] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesGet: async (id?: string, name?: string, description?: string, specialtyTypeId?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, languageCode?: string, ids?: Array<string>, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/specialties`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (description !== undefined) {
                localVarQueryParameter['Description'] = description;
            }

            if (specialtyTypeId !== undefined) {
                localVarQueryParameter['SpecialtyTypeId'] = specialtyTypeId;
            }

            if (marketingType !== undefined) {
                localVarQueryParameter['MarketingType'] = marketingType;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (created !== undefined) {
                localVarQueryParameter['Created'] = (created as any instanceof Date) ?
                    (created as any).toISOString() :
                    created;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (ids) {
                localVarQueryParameter['Ids'] = ids;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['ReturnDefaultValue'] = returnDefaultValue;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a Specialty.
         * @param {CreateSpecialtyCommand} [createSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesPost: async (createSpecialtyCommand?: CreateSpecialtyCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/specialties`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createSpecialtyCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all Specialties Simple.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {string} [specialtyTypeId] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [hospitalId] 
         * @param {Date} [created] 
         * @param {string} [languageCode] 
         * @param {Array<string>} [ids] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSimpleGet: async (id?: string, name?: string, description?: string, specialtyTypeId?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, languageCode?: string, ids?: Array<string>, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/specialties/simple`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (description !== undefined) {
                localVarQueryParameter['Description'] = description;
            }

            if (specialtyTypeId !== undefined) {
                localVarQueryParameter['SpecialtyTypeId'] = specialtyTypeId;
            }

            if (marketingType !== undefined) {
                localVarQueryParameter['MarketingType'] = marketingType;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (created !== undefined) {
                localVarQueryParameter['Created'] = (created as any instanceof Date) ?
                    (created as any).toISOString() :
                    created;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (ids) {
                localVarQueryParameter['Ids'] = ids;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['ReturnDefaultValue'] = returnDefaultValue;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary 
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSlugGet: async (slug: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'slug' is not null or undefined
            assertParamExists('apiV1SpecialtiesSlugGet', 'slug', slug)
            const localVarPath = `/api/v1/specialties/{slug}`
                .replace(`{${"slug"}}`, encodeURIComponent(String(slug)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Specialty.
         * @param {string} specialtyId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdDelete: async (specialtyId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyId' is not null or undefined
            assertParamExists('apiV1SpecialtiesSpecialtyIdDelete', 'specialtyId', specialtyId)
            const localVarPath = `/api/v1/specialties/{specialtyId}`
                .replace(`{${"specialtyId"}}`, encodeURIComponent(String(specialtyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Specialty.
         * @param {string} specialtyId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdGet: async (specialtyId: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyId' is not null or undefined
            assertParamExists('apiV1SpecialtiesSpecialtyIdGet', 'specialtyId', specialtyId)
            const localVarPath = `/api/v1/specialties/{specialtyId}`
                .replace(`{${"specialtyId"}}`, encodeURIComponent(String(specialtyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all SpecialtyMedias.
         * @param {string} specialtyId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdMediasGet: async (specialtyId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyId' is not null or undefined
            assertParamExists('apiV1SpecialtiesSpecialtyIdMediasGet', 'specialtyId', specialtyId)
            const localVarPath = `/api/v1/specialties/{specialtyId}/medias`
                .replace(`{${"specialtyId"}}`, encodeURIComponent(String(specialtyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (mediaType !== undefined) {
                localVarQueryParameter['MediaType'] = mediaType;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete SpecialtyMedia
         * @param {string} specialtyId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete: async (specialtyId: string, mediaId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyId' is not null or undefined
            assertParamExists('apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete', 'specialtyId', specialtyId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete', 'mediaId', mediaId)
            const localVarPath = `/api/v1/specialties/{specialtyId}/medias/{mediaId}`
                .replace(`{${"specialtyId"}}`, encodeURIComponent(String(specialtyId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get SpecialtyMedia.
         * @param {string} specialtyId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdMediasMediaIdGet: async (specialtyId: string, mediaId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyId' is not null or undefined
            assertParamExists('apiV1SpecialtiesSpecialtyIdMediasMediaIdGet', 'specialtyId', specialtyId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1SpecialtiesSpecialtyIdMediasMediaIdGet', 'mediaId', mediaId)
            const localVarPath = `/api/v1/specialties/{specialtyId}/medias/{mediaId}`
                .replace(`{${"specialtyId"}}`, encodeURIComponent(String(specialtyId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update SpecialtyMedia.
         * @param {string} specialtyId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdMediasMediaIdPut: async (specialtyId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyId' is not null or undefined
            assertParamExists('apiV1SpecialtiesSpecialtyIdMediasMediaIdPut', 'specialtyId', specialtyId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1SpecialtiesSpecialtyIdMediasMediaIdPut', 'mediaId', mediaId)
            const localVarPath = `/api/v1/specialties/{specialtyId}/medias/{mediaId}`
                .replace(`{${"specialtyId"}}`, encodeURIComponent(String(specialtyId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateMediaCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create SpecialtyMedia.
         * @param {string} specialtyId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdMediasPost: async (specialtyId: string, createMediaCommand?: CreateMediaCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyId' is not null or undefined
            assertParamExists('apiV1SpecialtiesSpecialtyIdMediasPost', 'specialtyId', specialtyId)
            const localVarPath = `/api/v1/specialties/{specialtyId}/medias`
                .replace(`{${"specialtyId"}}`, encodeURIComponent(String(specialtyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createMediaCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update Specialty.
         * @param {string} specialtyId 
         * @param {UpdateSpecialtyCommand} [updateSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdPut: async (specialtyId: string, updateSpecialtyCommand?: UpdateSpecialtyCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyId' is not null or undefined
            assertParamExists('apiV1SpecialtiesSpecialtyIdPut', 'specialtyId', specialtyId)
            const localVarPath = `/api/v1/specialties/{specialtyId}`
                .replace(`{${"specialtyId"}}`, encodeURIComponent(String(specialtyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateSpecialtyCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactivate Specialty.
         * @param {string} specialtyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdReactivatePut: async (specialtyId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyId' is not null or undefined
            assertParamExists('apiV1SpecialtiesSpecialtyIdReactivatePut', 'specialtyId', specialtyId)
            const localVarPath = `/api/v1/specialties/{specialtyId}/reactivate`
                .replace(`{${"specialtyId"}}`, encodeURIComponent(String(specialtyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Revalidate specialty
         * @param {string} specialtyId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdRevalidatePost: async (specialtyId: string, includeCurrent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyId' is not null or undefined
            assertParamExists('apiV1SpecialtiesSpecialtyIdRevalidatePost', 'specialtyId', specialtyId)
            const localVarPath = `/api/v1/specialties/{specialtyId}/revalidate`
                .replace(`{${"specialtyId"}}`, encodeURIComponent(String(specialtyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (includeCurrent !== undefined) {
                localVarQueryParameter['includeCurrent'] = includeCurrent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Translate specialty
         * @param {string} specialtyId 
         * @param {TranslateSpecialtyCommand} [translateSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdTranslatePost: async (specialtyId: string, translateSpecialtyCommand?: TranslateSpecialtyCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'specialtyId' is not null or undefined
            assertParamExists('apiV1SpecialtiesSpecialtyIdTranslatePost', 'specialtyId', specialtyId)
            const localVarPath = `/api/v1/specialties/{specialtyId}/translate`
                .replace(`{${"specialtyId"}}`, encodeURIComponent(String(specialtyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(translateSpecialtyCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SpecialtiesApi - functional programming interface
 * @export
 */
export const SpecialtiesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SpecialtiesApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all Specialties.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {string} [specialtyTypeId] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [hospitalId] 
         * @param {Date} [created] 
         * @param {string} [languageCode] 
         * @param {Array<string>} [ids] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesGet(id?: string, name?: string, description?: string, specialtyTypeId?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, languageCode?: string, ids?: Array<string>, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtiesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesGet(id, name, description, specialtyTypeId, marketingType, hospitalId, created, languageCode, ids, showHidden, returnDefaultValue, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a Specialty.
         * @param {CreateSpecialtyCommand} [createSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesPost(createSpecialtyCommand?: CreateSpecialtyCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtyModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesPost(createSpecialtyCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all Specialties Simple.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {string} [specialtyTypeId] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [hospitalId] 
         * @param {Date} [created] 
         * @param {string} [languageCode] 
         * @param {Array<string>} [ids] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesSimpleGet(id?: string, name?: string, description?: string, specialtyTypeId?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, languageCode?: string, ids?: Array<string>, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtiesSimpleModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesSimpleGet(id, name, description, specialtyTypeId, marketingType, hospitalId, created, languageCode, ids, showHidden, returnDefaultValue, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary 
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtyModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesSlugGet(slug, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Specialty.
         * @param {string} specialtyId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesSpecialtyIdDelete(specialtyId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesSpecialtyIdDelete(specialtyId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Specialty.
         * @param {string} specialtyId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesSpecialtyIdGet(specialtyId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtyModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesSpecialtyIdGet(specialtyId, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all SpecialtyMedias.
         * @param {string} specialtyId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesSpecialtyIdMediasGet(specialtyId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediasModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesSpecialtyIdMediasGet(specialtyId, id, mediaType, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete SpecialtyMedia
         * @param {string} specialtyId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete(specialtyId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete(specialtyId, mediaId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get SpecialtyMedia.
         * @param {string} specialtyId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesSpecialtyIdMediasMediaIdGet(specialtyId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesSpecialtyIdMediasMediaIdGet(specialtyId, mediaId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update SpecialtyMedia.
         * @param {string} specialtyId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesSpecialtyIdMediasMediaIdPut(specialtyId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesSpecialtyIdMediasMediaIdPut(specialtyId, mediaId, updateMediaCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create SpecialtyMedia.
         * @param {string} specialtyId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesSpecialtyIdMediasPost(specialtyId: string, createMediaCommand?: CreateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesSpecialtyIdMediasPost(specialtyId, createMediaCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update Specialty.
         * @param {string} specialtyId 
         * @param {UpdateSpecialtyCommand} [updateSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesSpecialtyIdPut(specialtyId: string, updateSpecialtyCommand?: UpdateSpecialtyCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SpecialtyModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesSpecialtyIdPut(specialtyId, updateSpecialtyCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactivate Specialty.
         * @param {string} specialtyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesSpecialtyIdReactivatePut(specialtyId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesSpecialtyIdReactivatePut(specialtyId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Revalidate specialty
         * @param {string} specialtyId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesSpecialtyIdRevalidatePost(specialtyId: string, includeCurrent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesSpecialtyIdRevalidatePost(specialtyId, includeCurrent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Translate specialty
         * @param {string} specialtyId 
         * @param {TranslateSpecialtyCommand} [translateSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SpecialtiesSpecialtyIdTranslatePost(specialtyId: string, translateSpecialtyCommand?: TranslateSpecialtyCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SpecialtiesSpecialtyIdTranslatePost(specialtyId, translateSpecialtyCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * SpecialtiesApi - factory interface
 * @export
 */
export const SpecialtiesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SpecialtiesApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all Specialties.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {string} [specialtyTypeId] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [hospitalId] 
         * @param {Date} [created] 
         * @param {string} [languageCode] 
         * @param {Array<string>} [ids] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesGet(id?: string, name?: string, description?: string, specialtyTypeId?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, languageCode?: string, ids?: Array<string>, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<SpecialtiesModel> {
            return localVarFp.apiV1SpecialtiesGet(id, name, description, specialtyTypeId, marketingType, hospitalId, created, languageCode, ids, showHidden, returnDefaultValue, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a Specialty.
         * @param {CreateSpecialtyCommand} [createSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesPost(createSpecialtyCommand?: CreateSpecialtyCommand, options?: any): AxiosPromise<SpecialtyModel> {
            return localVarFp.apiV1SpecialtiesPost(createSpecialtyCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all Specialties Simple.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {string} [specialtyTypeId] 
         * @param {MarketingType} [marketingType] 
         * @param {string} [hospitalId] 
         * @param {Date} [created] 
         * @param {string} [languageCode] 
         * @param {Array<string>} [ids] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSimpleGet(id?: string, name?: string, description?: string, specialtyTypeId?: string, marketingType?: MarketingType, hospitalId?: string, created?: Date, languageCode?: string, ids?: Array<string>, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<SpecialtiesSimpleModel> {
            return localVarFp.apiV1SpecialtiesSimpleGet(id, name, description, specialtyTypeId, marketingType, hospitalId, created, languageCode, ids, showHidden, returnDefaultValue, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary 
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<SpecialtyModel> {
            return localVarFp.apiV1SpecialtiesSlugGet(slug, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Specialty.
         * @param {string} specialtyId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdDelete(specialtyId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SpecialtiesSpecialtyIdDelete(specialtyId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Specialty.
         * @param {string} specialtyId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdGet(specialtyId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<SpecialtyModel> {
            return localVarFp.apiV1SpecialtiesSpecialtyIdGet(specialtyId, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all SpecialtyMedias.
         * @param {string} specialtyId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdMediasGet(specialtyId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<MediasModel> {
            return localVarFp.apiV1SpecialtiesSpecialtyIdMediasGet(specialtyId, id, mediaType, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete SpecialtyMedia
         * @param {string} specialtyId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete(specialtyId: string, mediaId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete(specialtyId, mediaId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get SpecialtyMedia.
         * @param {string} specialtyId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdMediasMediaIdGet(specialtyId: string, mediaId: string, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1SpecialtiesSpecialtyIdMediasMediaIdGet(specialtyId, mediaId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update SpecialtyMedia.
         * @param {string} specialtyId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdMediasMediaIdPut(specialtyId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1SpecialtiesSpecialtyIdMediasMediaIdPut(specialtyId, mediaId, updateMediaCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create SpecialtyMedia.
         * @param {string} specialtyId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdMediasPost(specialtyId: string, createMediaCommand?: CreateMediaCommand, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1SpecialtiesSpecialtyIdMediasPost(specialtyId, createMediaCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update Specialty.
         * @param {string} specialtyId 
         * @param {UpdateSpecialtyCommand} [updateSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdPut(specialtyId: string, updateSpecialtyCommand?: UpdateSpecialtyCommand, options?: any): AxiosPromise<SpecialtyModel> {
            return localVarFp.apiV1SpecialtiesSpecialtyIdPut(specialtyId, updateSpecialtyCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactivate Specialty.
         * @param {string} specialtyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdReactivatePut(specialtyId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SpecialtiesSpecialtyIdReactivatePut(specialtyId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Revalidate specialty
         * @param {string} specialtyId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdRevalidatePost(specialtyId: string, includeCurrent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SpecialtiesSpecialtyIdRevalidatePost(specialtyId, includeCurrent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Translate specialty
         * @param {string} specialtyId 
         * @param {TranslateSpecialtyCommand} [translateSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SpecialtiesSpecialtyIdTranslatePost(specialtyId: string, translateSpecialtyCommand?: TranslateSpecialtyCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SpecialtiesSpecialtyIdTranslatePost(specialtyId, translateSpecialtyCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1SpecialtiesGet operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesGetRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly description?: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly specialtyTypeId?: string

    /**
     * 
     * @type {MarketingType}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly marketingType?: MarketingType

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {Date}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly created?: Date

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {Array<string>}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly ids?: Array<string>

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly returnDefaultValue?: boolean

    /**
     * 
     * @type {number}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof SpecialtiesApiApiV1SpecialtiesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1SpecialtiesPost operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesPostRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesPostRequest {
    /**
     * 
     * @type {CreateSpecialtyCommand}
     * @memberof SpecialtiesApiApiV1SpecialtiesPost
     */
    readonly createSpecialtyCommand?: CreateSpecialtyCommand
}

/**
 * Request parameters for apiV1SpecialtiesSimpleGet operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSimpleGetRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSimpleGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly description?: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly specialtyTypeId?: string

    /**
     * 
     * @type {MarketingType}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly marketingType?: MarketingType

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {Date}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly created?: Date

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {Array<string>}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly ids?: Array<string>

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly returnDefaultValue?: boolean

    /**
     * 
     * @type {number}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof SpecialtiesApiApiV1SpecialtiesSimpleGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1SpecialtiesSlugGet operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSlugGetRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSlugGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSlugGet
     */
    readonly slug: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSlugGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesSlugGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdDelete operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdDeleteRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdDelete
     */
    readonly specialtyId: string

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdGet operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdGetRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdGet
     */
    readonly specialtyId: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdMediasGet operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGetRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGet
     */
    readonly specialtyId: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGet
     */
    readonly id?: string

    /**
     * 
     * @type {MediaType}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGet
     */
    readonly mediaType?: MediaType

    /**
     * 
     * @type {number}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdDeleteRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdDelete
     */
    readonly specialtyId: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdDelete
     */
    readonly mediaId: string
}

/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdMediasMediaIdGet operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdGetRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdGet
     */
    readonly specialtyId: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdGet
     */
    readonly mediaId: string
}

/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdMediasMediaIdPut operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdPutRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdPut
     */
    readonly specialtyId: string

    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdPut
     */
    readonly mediaId: string

    /**
     * 
     * @type {UpdateMediaCommand}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdPut
     */
    readonly updateMediaCommand?: UpdateMediaCommand
}

/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdMediasPost operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasPostRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasPostRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasPost
     */
    readonly specialtyId: string

    /**
     * 
     * @type {CreateMediaCommand}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasPost
     */
    readonly createMediaCommand?: CreateMediaCommand
}

/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdPut operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdPutRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdPut
     */
    readonly specialtyId: string

    /**
     * 
     * @type {UpdateSpecialtyCommand}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdPut
     */
    readonly updateSpecialtyCommand?: UpdateSpecialtyCommand
}

/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdReactivatePut operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdReactivatePutRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdReactivatePut
     */
    readonly specialtyId: string
}

/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdRevalidatePost operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdRevalidatePostRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdRevalidatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdRevalidatePost
     */
    readonly specialtyId: string

    /**
     * 
     * @type {boolean}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdRevalidatePost
     */
    readonly includeCurrent?: boolean
}

/**
 * Request parameters for apiV1SpecialtiesSpecialtyIdTranslatePost operation in SpecialtiesApi.
 * @export
 * @interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdTranslatePostRequest
 */
export interface SpecialtiesApiApiV1SpecialtiesSpecialtyIdTranslatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdTranslatePost
     */
    readonly specialtyId: string

    /**
     * 
     * @type {TranslateSpecialtyCommand}
     * @memberof SpecialtiesApiApiV1SpecialtiesSpecialtyIdTranslatePost
     */
    readonly translateSpecialtyCommand?: TranslateSpecialtyCommand
}

/**
 * SpecialtiesApi - object-oriented interface
 * @export
 * @class SpecialtiesApi
 * @extends {BaseAPI}
 */
export class SpecialtiesApi extends BaseAPI {
    /**
     * 
     * @summary Get all Specialties.
     * @param {SpecialtiesApiApiV1SpecialtiesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesGet(requestParameters: SpecialtiesApiApiV1SpecialtiesGetRequest = {}, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesGet(requestParameters.id, requestParameters.name, requestParameters.description, requestParameters.specialtyTypeId, requestParameters.marketingType, requestParameters.hospitalId, requestParameters.created, requestParameters.languageCode, requestParameters.ids, requestParameters.showHidden, requestParameters.returnDefaultValue, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a Specialty.
     * @param {SpecialtiesApiApiV1SpecialtiesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesPost(requestParameters: SpecialtiesApiApiV1SpecialtiesPostRequest = {}, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesPost(requestParameters.createSpecialtyCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all Specialties Simple.
     * @param {SpecialtiesApiApiV1SpecialtiesSimpleGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesSimpleGet(requestParameters: SpecialtiesApiApiV1SpecialtiesSimpleGetRequest = {}, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesSimpleGet(requestParameters.id, requestParameters.name, requestParameters.description, requestParameters.specialtyTypeId, requestParameters.marketingType, requestParameters.hospitalId, requestParameters.created, requestParameters.languageCode, requestParameters.ids, requestParameters.showHidden, requestParameters.returnDefaultValue, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary 
     * @param {SpecialtiesApiApiV1SpecialtiesSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesSlugGet(requestParameters: SpecialtiesApiApiV1SpecialtiesSlugGetRequest, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesSlugGet(requestParameters.slug, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Specialty.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesSpecialtyIdDelete(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdDeleteRequest, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesSpecialtyIdDelete(requestParameters.specialtyId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Specialty.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesSpecialtyIdGet(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdGetRequest, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesSpecialtyIdGet(requestParameters.specialtyId, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all SpecialtyMedias.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesSpecialtyIdMediasGet(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasGetRequest, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesSpecialtyIdMediasGet(requestParameters.specialtyId, requestParameters.id, requestParameters.mediaType, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete SpecialtyMedia
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdDeleteRequest, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesSpecialtyIdMediasMediaIdDelete(requestParameters.specialtyId, requestParameters.mediaId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get SpecialtyMedia.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesSpecialtyIdMediasMediaIdGet(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdGetRequest, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesSpecialtyIdMediasMediaIdGet(requestParameters.specialtyId, requestParameters.mediaId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update SpecialtyMedia.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesSpecialtyIdMediasMediaIdPut(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasMediaIdPutRequest, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesSpecialtyIdMediasMediaIdPut(requestParameters.specialtyId, requestParameters.mediaId, requestParameters.updateMediaCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create SpecialtyMedia.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesSpecialtyIdMediasPost(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdMediasPostRequest, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesSpecialtyIdMediasPost(requestParameters.specialtyId, requestParameters.createMediaCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update Specialty.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesSpecialtyIdPut(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdPutRequest, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesSpecialtyIdPut(requestParameters.specialtyId, requestParameters.updateSpecialtyCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactivate Specialty.
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesSpecialtyIdReactivatePut(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesSpecialtyIdReactivatePut(requestParameters.specialtyId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Revalidate specialty
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesSpecialtyIdRevalidatePost(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdRevalidatePostRequest, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesSpecialtyIdRevalidatePost(requestParameters.specialtyId, requestParameters.includeCurrent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Translate specialty
     * @param {SpecialtiesApiApiV1SpecialtiesSpecialtyIdTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SpecialtiesApi
     */
    public apiV1SpecialtiesSpecialtyIdTranslatePost(requestParameters: SpecialtiesApiApiV1SpecialtiesSpecialtyIdTranslatePostRequest, options?: AxiosRequestConfig) {
        return SpecialtiesApiFp(this.configuration).apiV1SpecialtiesSpecialtyIdTranslatePost(requestParameters.specialtyId, requestParameters.translateSpecialtyCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
